#include<bits/stdc++.h>
using namespace std;
char rec[200050];
int niz[200050][35];
int mini, priv;
int broj;
int n,k;
char pos;
int main ()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    //freopen("test.in", "r", stdin);
    //freopen("test1.izlaz", "w", stdout);
    cin >> n >> k;
    ///PRIPREMA DP-A
    for(int i=1; i<=n; i++)
    {
        cin >> rec[i];
        for(int j = 1; j<=k; j++) ///OVAJ JE PROSLI + 1
            niz[i][j] = niz[i-1][j];
        niz[i][int(rec[i]) - 96]++; /// DODAM GA KAKO JE
    }

    priv = 1e9;
    for(int i=1; i<=n; i++)
    {
        mini = priv;
        for(int j = 1; j<=k; j++)
        {
            //cout << niz[i][j] << " ";
            mini = min(mini, niz[i][j]);
            
        }
        //cout << ", ";
        ///UZMEM NAJBOLJI TRENUTNI

        for(int j = 1; j<=k; j++)
        {
            broj = niz[n][j] - niz[i][j];
            //cout << broj << " ";
            mini = min(mini, broj);
        }
        if(mini == 25)
            priv = 25;
        cout << mini+1 << " ";
        //cout << endl;
        ///UZMEM NAJBOLJI DO KRAJA
    }
    cout << "\n";
    return 0;
}
///NE RADI
/*
8
3
aaabbbcc

*/